<template>
    <div>
        <form class="card auth-card" @submit.prevent="submitHandler" >
  <div class="card-content">
    <span class="card-title">Домашняя бухгалтерия</span>
    <div class="input-field">
            <input id="email" type="text" v-model.trim="email"
             :class="{invalid: (v$.email.$dirty && !v$.email.required) || (v$.email.$dirty && !v$.email.email) }" />
              <label for="email">Email <span class="required">*</span> </label>
              <!-- <small class="helper-text invalid"
              v-if="v$.email.$dirty && !v$.email.required">
              Polya email pustoy
              </small>
              <small class="helper-text invalid"
              v-else-if="v$.email.$dirty && !v$.email.email">
              Email noto'g'ri
              </small> -->

            <small class="helper-text invalid" v-for="(error, index) of v$.email.$errors" :key="index">
              {{ error.$property }} {{error.$message}}
            </small>
           
        </div>
    <div class="input-field">
          <input id="password" type="password" v-model.trim="password" />
          <label for="password">Пароль</label>
          <small class="helper-text invalid" v-for="(error, index) of v$.password.$errors" :key="index">
              {{ error.$property }} {{error.$message}}
            </small>
        </div>
    <div class="input-field">
      <input id="name" type="text" v-model.trim="name" />
      <label for="name">Имя</label>
      <small class="helper-text invalid" v-for="(error, index) of v$.name.$errors" :key="index">
              {{ error.$property }} {{error.$message}}
            </small>
    </div>
    <p>
      <label>
        <input type="checkbox" v-model="agree" />
        <span>С правилами согласен</span>
      </label>
    </p>
  </div>
  <div class="card-action">
    <div>
      <button
          class="btn waves-effect waves-light auth-submit"
          type="submit"
      >
        Зарегистрироваться
        <i class="material-icons right">send</i>
      </button>
    </div>

    <p class="center">
      Уже есть аккаунт?
      <router-link to="/login">Войти!</router-link>
    </p>
  </div>
</form>
    </div>
</template>

<script>
import { useVuelidate } from "@vuelidate/core";
import { email, required, minLength } from "@vuelidate/validators";


export default {
  setup() {
    return { v$: useVuelidate() };
  },
  name: "register",
  data: () => ({
    name: "",
    agree: false,
    email: "",
    password: ""
  }),
  validations() {
    return {
      email: { required, email },
      password: { required, minLength: minLength(6) },
      name: { required },
      agree: { checked: v => v }
    };
  },
  methods: {
    async submitHandler() {
      this.v$.$touch();
      if (this.v$.$error) return;

      const formdata = {
        email: this.email,
        password: this.password,
        name:this.name,
      };

      try{ 

        await this.$store.dispatch('register',formdata);

        this.$router.push("/home");
      }catch(e){
        console.log({e});
         this.$error(e.code);
        // this.$error(messages[this.$route.query.message] || "Nima xato ketganini tushunmadim")
      }
      
    }
  }
};
</script>